using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.Sql;
using System.Data.SqlClient;
using System.Data.OleDb;
using Syncfusion.Windows.Forms.Grid;




namespace SyncfusionTesting
{
    public partial class Form1 : Form
    {




        private SqlDataAdapter TestingDataAdapter = new SqlDataAdapter();

        private const string WorkstationName = "gdfkjgdhf";
        private const string InstanceName = "SQLEXPRESS";
        private const string InitialCatalog = "pubs";


        private const string SQLConnectionString = "workstation id=" + WorkstationName + ";packet size=4096;integrated security=SSPI;data source=\"(local)\\" + InstanceName + "\";persist security info=False;initial catalog = " + InitialCatalog + ";";
        //private const string SQLConnectionString = "Provider=SQLNCLI;Server=(local)\\SqlExpress;Database=pubs;Trusted_Connection=yes;";
        //this datatable is shared by all functions
        private DataTable dataTableUse = new DataTable("employee2");

        //this dataset is shared by all functions
        private DataSet datasetUse = new DataSet("employee1");

        //private DataGridColumnStyle GenericCStyle = new DataGridTextBoxColumn();




        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {



            //gridDataBoundGrid1.ControllerOptions |= GridControllerOptions.DragColumnHeader;

            gridDataBoundGrid1.AllowDragSelectedCols = true;


        }


        private void buttonLoadData_Click(object sender, EventArgs e)
        {


            string strFillDataSetCmd = "SELECT * FROM TwoThousandRowTable;";


            SqlConnection SqlCn = new SqlConnection(SQLConnectionString);

            SqlCommand cmdFillDataset = new SqlCommand(strFillDataSetCmd, SqlCn);


            //set the command string the dataadapter will use to 
            TestingDataAdapter.SelectCommand = cmdFillDataset;

            //exception if schema is missing
            TestingDataAdapter.MissingSchemaAction = MissingSchemaAction.Error;


            try
            {
                //fill the datset with schema first
                TestingDataAdapter.FillSchema(datasetUse, SchemaType.Source);

                //next, fill the dataset with data
                TestingDataAdapter.Fill(datasetUse);




            }

            catch (SqlException ex)
            {

                //show the exception
                MessageBox.Show(ex.ToString());
            }



            dataTableUse = datasetUse.Tables[0];


            gridDataBoundGrid1.AllowResizeToFit = true;

            gridDataBoundGrid1.DataSource = dataTableUse;
            gridDataBoundGrid1.AccelerateScrolling = Syncfusion.Windows.Forms.AccelerateScrollingBehavior.Default;


            this.gridDataBoundGrid1.TableStyle.Themed = true;

            //gridDataBoundGrid1.Model.TableStyle = Syncfusion.Windows.Forms;





        }



        private void buttonSaveChanges_Click(object sender, EventArgs e)
        {



            this.gridDataBoundGrid1.CurrentCell.Deactivate(true);
            this.gridDataBoundGrid1.Binder.GridBoundColumns.Clear();
            this.gridDataBoundGrid1.Binder.InternalColumns.Clear();
            this.gridDataBoundGrid1.Binder.SuspendBinding();
            this.gridDataBoundGrid1.BeginUpdate();
            this.gridDataBoundGrid1.DataSource = null;
            this.gridDataBoundGrid1.DataMember = "";
            this.gridDataBoundGrid1.Model.ResetVolatileData();
            this.gridDataBoundGrid1.DataSource = dataTableUse;
            this.gridDataBoundGrid1.EndUpdate(true);
            this.gridDataBoundGrid1.Binder.ResumeBinding();
            this.gridDataBoundGrid1.Refresh();



        }












        private void buttonAutofit_Click(object sender, EventArgs e)
        {

            //not done, have to figure out how many columns there are in the grid
            //gridDataBoundGrid1.Model.RowHeights.ResizeToFit(Syncfusion.Windows.Forms.Grid.GridRangeInfo.Rows(0, 10));

            gridDataBoundGrid1.Model.ColWidths.ResizeToFit(Syncfusion.Windows.Forms.Grid.GridRangeInfo.Table());

            //MessageBox.Show(gridDataBoundGrid1.Model.ColCount.ToString());
        
        }

        private void buttonReorder_Click(object sender, EventArgs e)
        {




            gridDataBoundGrid1.Binder.LayoutColumns(new string[] { "Age", "First_Name", "Last_Name", "HeightInches", "WeightLbs" });

            //You can also move columns in the DataBoundGrid, using the grid.Model.Cols.MoveRange method. See the code below,

            // moves column 1 to 3
            //gridDataBoundGrid1.Model.Cols.MoveRange(1, 3);



        }

        private void buttonHide_Click(object sender, EventArgs e)
        {
            gridDataBoundGrid1.Model.HideCols["Age"] = true;
        }

        private void buttonLoadLargeData_Click(object sender, EventArgs e)
        {




            string strFillDataSetCmd = "SELECT * FROM FiveHundredRowTable;";


            SqlConnection SqlCn = new SqlConnection(SQLConnectionString);

            SqlCommand cmdFillDataset = new SqlCommand(strFillDataSetCmd, SqlCn);


            //set the command string the dataadapter will use to 
            TestingDataAdapter.SelectCommand = cmdFillDataset;

            //exception if schema is missing
            TestingDataAdapter.MissingSchemaAction = MissingSchemaAction.Error;


            try
            {
                //fill the datset with schema first
                TestingDataAdapter.FillSchema(datasetUse, SchemaType.Source);

                //next, fill the dataset with data
                TestingDataAdapter.Fill(datasetUse);




            }

            catch (SqlException ex)
            {

                //show the exception
                MessageBox.Show(ex.ToString());
            }



            dataTableUse = datasetUse.Tables[0];


            gridDataBoundGrid1.AllowResizeToFit = true;

            gridDataBoundGrid1.DataSource = dataTableUse;
            gridDataBoundGrid1.AccelerateScrolling = Syncfusion.Windows.Forms.AccelerateScrollingBehavior.Default;


            this.gridDataBoundGrid1.TableStyle.Themed = true;

            //gridDataBoundGrid1.Model.TableStyle = Syncfusion.Windows.Forms;





        }

        private void buttonTurnOffScrolling_Click(object sender, EventArgs e)
        {


            gridDataBoundGrid1.AccelerateScrolling = Syncfusion.Windows.Forms.AccelerateScrollingBehavior.Immediate;



        }

        private void buttonTurnOnScrolling_Click(object sender, EventArgs e)
        {

            gridDataBoundGrid1.AccelerateScrolling = Syncfusion.Windows.Forms.AccelerateScrollingBehavior.Default;




        }


    
    
    
    
    }



}